%define name kernel
%define srl 2002111901
%define rel 13.3
%define sublevel 18
%define ver 2.2.%{sublevel}

%define BIGMEM 1
%define EXT3 1
%define RESIZE 1
%define REISER 1
%define ASYNC 1
%define UNICON 1
%define CLUSTER 1
%define COMPILER egcs

%define pcmciaver 3.1.24
%define ibcsver 2.1-981105
%define ksymoopsver 0.7c
%define ALSAver 0.5.10b
%define E100_VER 1.6.5
%define E1000_VER 3.0.10
%define ninjaver 1.1.4

%define __spec_install_post /usr/lib/rpm/brp-compress || :
# --------------------------------------------------------------------
# Please initial this as it's worked on for each architecture:
# i386   : go
# i586   : go
# i686   : go
# alpha  : sb
# ppc    : 
# s390	 : 
# --------------------------------------------------------------------
Summary: The Linux kernel (the core of the Linux operating system).
Name:    %{name}
Version: %{ver}
Release: %{rel}
Serial:  %{srl}
Group: System Environment/Kernel
URL: http://www.kernel.org
Copyright: GPL
ExclusiveArch: i386 i586 i686 alpha sparc sparc64 ppc s390
ExclusiveOS: Linux
Obsoletes: kernel-modules kernel-sparc alsa-driver
Provides: module-info alsa-driver
Autoreqprov: no
Requires: initscripts >= 3.64
Prereq: chkconfig modutils fileutils /sbin/ldconfig gawk grep textutils
%ifarch i386 i586 i686
BuildRequires: %{COMPILER}
%endif
BuildRoot: /var/tmp/kernel-%{ver}-root
%define KVERREL %{PACKAGE_VERSION}-%{PACKAGE_RELEASE}
#---------------------------------------------------------------
# Main Source
Source0: ftp://ftp.kernel.org/pub/linux/kernel/v2.2/linux-%{ver}.tar.gz
Source1: ftp://projects.sourceforge.net/pub/pcmcia-cs/pcmcia-cs-%{pcmciaver}.tar.gz
Source2: ftp://tsx-11.mit.edu/pub/linux/BETA/ibcs2/ibcs-%{ibcsver}.tar.gz
Source3: ftp://ftp.ocs.com.au/pub/ksymoops/ksymoops-%{ksymoopsver}.tar.gz

# Other Source
Source5: ftp://ftp.alsa-project.org/pub/driver/alsa-driver-%{ALSAver}.tar.bz2
%if %{UNICON}
Source6: unicon-3.0.2.tar.gz
%endif

%ifarch ppc
Source8: ramdisk.image.gz-ppc
%endif

# Additional Source
Source10: linux-SetupKernelSource.sh
Source11: module-info
Source12: installkernel
Source13: rhkmvtag.c
Source14: kernel-2.2-BuildASM.sh
Source15: linux-autoconf.h
Source16: linux-version.h
Source17: linux-modversions.h

# Config file
Source20: kernel-%{PACKAGE_VERSION}-i386.config
Source21: kernel-%{PACKAGE_VERSION}-alpha.config
Source22: kernel-%{PACKAGE_VERSION}-s390-IPLvrdr.config
Source23: kernel-%{PACKAGE_VERSION}-s390-IPLtape.config

# Network Drivers
#Source30: ftp://download.intel.com/df-support/1999/eng/e100-%{E100_VER}.tgz
#Source31: ftp://download.intel.com/df-support/2000/eng/e1000-%{E1000_VER}.tar.gz
Source32: http://support.3com.com/infodeli/tools/nic/linux/3c90x-1.0.0i.tar.gz
#Source33: http://support.3com.com/infodeli/tools/nic/linux/3c990-1.0.0a.tar.gz
Source34: ftp://cesdis.gsfc.nasa.gov/pub/linux/drivers/rtl8139.c
Source35: ftp://cesdis.gsfc.nasa.gov/pub/linux/drivers/test/winbond-840.c
Source36: ftp://cesdis.gsfc.nasa.gov/pub/linux/drivers/via-rhine.c
#http://www.scyld.com/network/
Source37: becker-drivers-010128.tar.gz

# SCSI Drivers
Source40: dc395-123.tar.gz
# Misc
Source41: userlink-0.99c.tar.gz
# Video
Source42: I810Gtt-0.2.tar.gz
# Modem
Source43: CLModem-0.3.0.tar.gz

# PCMCIA Other Source
Source50: pcmcia-cs-3.1.21-network.script
Source51: pcmcia-tl.config
Source52: pcmcia-tl.config.opts
Source53: ftp://sourceforge.org/pcmcia/contrib/wireless_tools.20.tar.gz
Source54: http://www.netlab.is.tsukuba.ac.jp/~yokota/archive/nsp_cs-%{ninjaver}.tar.gz
Source55: http://154.33.4.60/pub/lan/lpc3tx-v1.00a.tar.gz
Source56: http://www.linux-wlan.com/linux-wlan/linux-wlan-ng-0.1.7.tar.gz

# Document and Other
Source60: README.kernel-sources
Source61: README.kernel-sources.ja_JP.eucJP
Source62: README.kernel-sources.zh_CN
Source63: README.kernel-sources.zh_TW.Big5
Source64: MAKEDEV.usb
Source65: pcimodules.dat
Source66: usbdet.c
#---------------------------------------------------------------
#
#   Patch Number Rules:
#   1-100   System Patch
#   100-300 Hardware Patch
#   300-400 Platform Patch
#
#

#---------------- System Patch 1-100 ------------------------
#------ Pre Patch 0 - 5 ------
Patch1: 2.2.18aa2
Patch2: linux-2.2.18-fix.patch
Patch3: linux-2.2.18-sysctl.patch
Patch4: linux-2.2.18-ptrace.patch
Patch5: linux-2.2.18-secure.patch
#------ Kernel Build Patch 6 - 15 ------ 
Patch6: kernel-2.2.15-TLbuildnames.patch
Patch7: kernel-2.2.15-symversion.patch
Patch8: linux-2.2.14-nobfddep.patch
Patch9: kernel-2.2.18-egcs.patch
Patch10: ibcs-config.patch
Patch11: kernel-2.2.16-MLbuildnames.patch
Patch12: linux-2.2.18-ibcs-kill_fasync.patch
Patch13: linux-2.2.18-Make-MODULES.patch
#---------------- System Enchancement -------------------
#----- Large File  16-20 ------
#----- Raw IO	21-25 ------	
#----- Process Number 26-30 -----
Patch26: kernel-2.2.18-limits.patch
#----- Cluster 31-35 -----
Patch31: kernel-2.2.16-tc-stub.patch
Patch32: arm.2.2.18-1.turbo.patch
#----- ipvs Patch 36-40 -----
Patch36: ipvs-1.0.0-2.2.18.patch
#----- Async IO 41-45 -----
Patch41: kaio-kern-1.1-2.2.18
Patch42: ftp://oss.sgi.com/www/projects/kaio/download/kaio-lib-1.1-2.2.13
#----- Bigmem Patch 46-50 -----
#----- I18N Patch 51-55 -----
%if %{UNICON}
Patch51: unicon-kernel-2.2.18-1.patch
%endif
#------ Misc 56-70 -----
Patch56: kernel-2.2.18-nmihook.patch
Patch57: linux-2.2.17-proc-semopm.patch
Patch58: kernel-2.2.15-mlockcontention.patch
Patch59: linux-2.2.16-quiet.patch
Patch60: linux-2.2.16-loop.patch
Patch61: linux-2.2.18-loop-F1.patch
Patch62: linux-2.2.18-loop-F1-1.patch
Patch63: linux-2.2.18-loop-F1-2.patch
#------ File System 71-90 ------
# NFS
Patch71: linux-2.2.18-nfs-2219pre13aa1.patch
# UDF
Patch72: linux-2.2.18-udf.patch
# ext3
%if %{EXT3}
Patch73: kdb-ext3-0.0.5-2.2.18.patch
Patch74: ext3-TL.patch
Patch75: ext3-aed.diff
Patch76: rootfs-postext3-2.2.18.patch
Patch78: ext3-lfs.diff
Patch84: ext3-defopt-journal.patch
%endif
#ext2 - fix COMPAT flag bug
Patch77: linux-2.2.18-ext2compat.diff
%if %{RESIZE}
Patch79: ext2-resize.diff
%endif
# reiserfs
#ftp://ftp.reiserfs.org/pub/
%if %{REISER}
Patch80: linux-2.2.18-reiserfs-3.5.29-patch
Patch81: reiserfs-3.5.29-lfs.diff
%endif
# sysv
Patch82: sysv-2.2.18-lfs.patch

Patch83: linux-2.2.18-bdflushtime.patch

#------------------- HardWare Patch 100 - 300 ----------------

# ------ CPU         	101-105		------
Patch101: linux-2.2.18-cpuinfo.patch
Patch102: linux-2.2.18-p4-cachesize.patch
Patch103: linux-2.2.18-VIA-C3.patch
# ------ PCI            106-110         ------
Patch106: linux-2.2.16-i82801AAfix.patch
Patch107: linux-2.2.18-i860-ioapic.patch
Patch108: linux-2.2.18-viafix.patch
Patch109: athlon760mp.patch
# ------ SCSI           111-130         ------
Patch111: linux-2.2.16-scsi-reservation.patch
Patch115: linux-2.2.17-dc390-20d25.diff
Patch116: linux-2.2.18-NewQlogic.patch
Patch117: linux-2.2.18-sym53c8xx-search.patch
Patch118: aic7xxx-5.1.33.patch.gz
Patch119: aic7xxx-5.1.34.patch.gz
Patch120: aic7xxx-5.1.31a.patch.gz
Patch121: aic7xxx-5.1.31b.patch.gz
Patch122: extra_devs.diff.gz
Patch123: not_ready.gz
Patch124: scsi_reset_2_2_18_inc.diff
Patch125: linux-inia100-850.patch
Patch126: linux-2.2.17-scsi-scan.patch
# ------ Hardware RAID  131-135         ------
Patch131: linux-2.2.18-aacraid-1.0.6.patch
Patch132: linux-2.2.18-megaraid-107b.patch
Patch133: linux-2.2.18-ips-4.80.patch
Patch134: linux-2.2.18-dpti2o-2.3.3.patch
Patch135: linux-2.2.18-DAC960-2.2.10.patch
Patch138: linux-2.2.18-cciss-1.0.3.patch
Patch139: linux-2.2.18-aacraid-5400S.patch
Patch140: linux-2.2.18-3w-xxxx-1.02.00.008.patch
# ------ IDE            136-140         ------
Patch136: ide.2.2.18.1221.patch
Patch137: linux-2.2.18-mc146818rtc.h-spinlock.patch
# ------ Ethernet       141-160         ------
Patch141: linux-2.2.18-newnic.patch
Patch143: linux-2.2.18-userlink.patch
Patch144: smctr-2.2.12-1.4.diff
Patch145: linux-2.2-e100-%{E100_VER}.patch
Patch146: linux-2.2-e1000-%{E1000_VER}.patch
Patch147: linux-2.2-e100_e1000_non_x86.patch
Patch148: linux-2.2.18-defxx-eisa-check.patch
# ------ Sound          161-170         ------
Patch161: alsa-driver-install.patch
Patch162: alsa-0.4.1i-default_off
# ------ Serial         171-175         ------
Patch171: linux-2.2.15-serial-fixSMP.patch
Patch172: kernel-2.2.17-cyc_async-6.5.9.patch
# ------ Video          176-180         ------
Patch176: linux-2.2.18-i810.diff
Patch177: linux-2.2.18-vga16fb.patch
Patch178: linux-2.2.18-agp.patch
Patch179: linux-2.2.18-atyfb-mod.patch
# ------ I2O            181-190         ------
Patch181: linux-2.2.16-i2opci-defoff.patch
Patch182: linux-2.2.15-i2opci-rade.patch
# ------ USB IEEE1394   191-200         ------
Patch191: linux-2.2.18-usb-fix.patch
Patch192: linux-2.2.18-keybdeb-jp106.patch
#http://download.sourceforge.net/linux1394/ieee1394-2.2.18-20001223.gz
Patch193: ieee1394-2.2.18-20001223
#http://firewire.zawa.com/sbp2/sbp2_1394_122300.tar.gz
Patch194: linux-2.2.18-ieee1394.patch
Patch195: usb-storage-RATOC_CFreader.diff
Patch196: pegasus.c.melco.patch
Patch197: linux-2.2.18-usbstorage-DSC.patch
# ------ PCMCIA         201-220         ------
Patch201: pcmcia-cs-3.1.15-script.patch
Patch202: pcmcia-cs-3.1.24-ohci1394_stub.patch
Patch203: pcmcia-cs-3.1.14-config.patch
Patch204: pcmcia-cs-3.1.23-tulip.patch
Patch205: pcnet_cs.c.patch
Patch206: libpcmcia.patch
Patch207: pcmcia-cs-3.1.24-addmake.patch
Patch208: linux-wlan-ng-0.1.7-make.patch
Patch209: pcmcia-cs-3.1.24-fixup-MXfix.patch
Patch210: pcmcia-cs-3.1.24-apa1480-newaic.patch
Patch211: pcmcia-cs-3.1.27-ide_cs-kxlc.patch

# ------ Misc           271-300         ------
Patch271: psaux.diff
Patch272: linux-2.2.16-clmodem-make.patch
Patch273: kernel-2.2.17-pc300.patch
Patch274: ftp://irda.sourceforge.net/pub/irda/patches/patch-2.2.18-23-irda1
Patch280: http://www.strusel007.de/linux/bttv/i2c-2.2.18.diff.gz
Patch281: linux-2.2.18-watchdog-nowayout.patch
Patch282: linux-2.2.18-bttv-0.7.62.patch

#------------------- other platform 301 - 400 ----------------
# ------ Alpha 301-320 ------
# ------ Sparc 321-340 ------
# ------ PPC   341-360 ------
#Patch341: kernel-ppc-planb.patch
# ------ S390  361-380 ------
Patch361: linux-2.2.16-s390.diff
Patch362: linux-2.2.16-s390-hwc.diff
# ------ IA64  381-400 ------

# ------ Miracle 500-XXX ------
Patch500: linux-2.2.18-zlib.patch
Patch501: linux-2.2.18-security_lcall.patch


%package source
Summary: The source code for the Linux kernel.
Group: Development/System
#Requires: kernel-headers = %{KVERREL}
Prereq: fileutils gawk

%package headers
Summary: Header files for the Linux kernel.
Group: Development/System
%ifarch i386 i586 i686
Requires: initscripts >= 4.9.0
Prereq: fileutils gawk
%endif

%package doc
Summary: Various documentation bits found in the kernel source.
Group: Documentation

%package pcmcia-cs
Summary: The daemon and device drivers for using PCMCIA adapters.
Group: System Environment/Kernel
Obsoletes: pcmcia-cs
Prereq: fileutils chkconfig grep modutils

%package utils
Summary: Kernel related utilities.
Group: System Environment/Kernel

%package ibcs
Summary: Files which allow iBCS2 programs to run.
Group: System Environment/Kernel
Obsoletes: iBCS

%package smp
Summary: The Linux kernel compiled for SMP machines.
Group: System Environment/Kernel
Requires: kernel = %{KVERREL}
Prereq: chkconfig modutils fileutils

%package BOOT
Summary: The version of the Linux kernel used on installation boot disks.
Group: System Environment/Kernel

%package BOOTsmp
Summary: The Linux kernel used on installation boot disks for SMP machines.
Group: System Environment/Kernel

%package IPLtape
Summary: The Linux kernel used in S/390 when booting from tapes.
Group: System Environment/Kernel

%package IPLvrdr
Summary: The Linux kernel used in S/390 when booting from the VM reader.
Group: System Environment/Kernel

%package extramodules
Summary: The Linux kernel extra modules
Group: System Environment/Kernel
Copyright: distributable

%description
The kernel package contains the Linux kernel (vmlinuz), the core of your
Linux operating system.  The kernel handles the basic functions
of the operating system:  memory allocation, process allocation, device
input and output, etc.

%description source
The kernel-source package contains the source code files for the Linux
kernel. These source files are needed to build most C programs, since
they depend on the constants defined in the source code. The source
files can also be used to build a custom kernel that is better tuned
to your particular hardware, if you are so inclined (and you know what
you're doing).

%description headers
Kernel-headers includes the C header files for the Linux kernel.  The
header files define structures and constants that are needed for
building most standard programs and are also needed for rebuilding the
kernel.

%description doc
This package contains documentation files form the kernel
source. Various bits of information about the Linux kernel and the
device drivers shipped with it are documented in these files. 

You'll want to install this package if you need a reference to the
options that can be passed to Linux kernel modules at load time.

%description pcmcia-cs
Many laptop machines (and some non-laptops) support PCMCIA cards for
expansion. Also known as "credit card adapters," PCMCIA cards are
small cards for everything from SCSI support to modems. PCMCIA cards
are hot swappable (i.e., they can be exchanged without rebooting the
system) and quite convenient to use. The kernel-pcmcia-cs package
contains a set of loadable kernel modules that implement an
applications program interface, a set of client drivers for specific
cards and a card manager daemon that can respond to card insertion and
removal events by loading and unloading drivers on demand.  The daemon
also supports hot swapping, so that the cards can be safely inserted
and ejected at any time.

Install the kernel-pcmcia-cs package if your system uses PCMCIA
cards.

%description utils
The kernel-utils package contains ksymoops, a utility that can be used
for decrypting the kernel's OOPS output.

%description ibcs
The kernel-ibcs package allows you to run programs in the iBCS2 (Intel
Binary Compatibility Standard, version 2) and related executable
formats.  iBCS is a standard for binary portability between UNIX and
UNIX-like systems.

%description smp
This package includes a SMP version of the Linux kernel. It is
required only on machines with two or more CPUs, although it should
work fine on single-CPU boxes.

Install the kernel-smp package if your machine uses two or more CPUs.

%description BOOT
This package includes a trimmed down version of the Linux kernel.
This kernel is used on the installation boot disks only and should not
be used for an installed system, as many features in this kernel are
turned off because of the size constraints.

%description BOOTsmp
This package includes a trimmed down version of the Linux kernel. This
kernel is used on the installation boot disks only and should not be used
for an installed system, as many features in this kernel are turned off
because of the size constraints. This kernel is used when booting SMP
machines that have trouble coming up to life with the uniprocessor kernel.

%description IPLtape
This package contains the kernel used to boot from tape on IBM S/390 machines.

%description IPLvrdr
This package contains the kernel used to boot from VM reader 
on IBM S/390 machines.

%description extramodules
This package contains the kernel extra modules

Summary: The Linux kernel extra modules
# --------------------------------------------------------------------

%prep
%setup -q -n linux -a1 -a2 -a3 -a5 -a40
mkdir configs

#### System Patch
# Big Patch
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

# Kernel Build
if [ ! -f /etc/miraclelinux-release ]; then
%patch6 -p1
else
%patch11 -p1
fi
%patch7 -p1
%patch8 -p1
%ifarch i386 i586 i686
%patch9 -p1
%patch10 -p0
%patch12 -p0
%endif
%patch13 -p1

#### System Enchancement
#Large File

#Raw IO

#Process Number
%patch26 -p1

%if %{CLUSTER}
%patch31 -p1
%patch32 -p1
%endif

#ipvs Patch
%patch36 -p1

#I18N Patch
%if %{UNICON}
tar zxf %{SOURCE6}
%patch51 -p1
%endif

#Misc
%patch56 -p1
%ifarch i386 i586 i686
# this is needed by Oracle
%patch57 -p1
%endif
%patch58 -p1
%patch59 -p1
%patch60 -p1
%patch61 -p1

## File System
#NFS
%patch71 -p1

#UDF
%patch72 -p1

#Serial
%ifarch i386 i586 i686
%patch171 -p1
%endif
%patch172 -p1

#ext3
%if %{EXT3}
%patch73 -p1
%patch74 -p1
%patch75 -p1
%patch76 -p1
%patch78 -p1
%patch84 -p1
%patch63 -p1
%else
%patch62 -p
%endif

#ext2 COMPAT bugfix
%patch77 -p1

#online ext2 filesystem resizing
%if %{RESIZE}
%patch79 -p1
%endif

#reiserfs
%if %{REISER}
sed -e s/journal_release/reiserfs_journal_release/g -e s/buffer_journaled/reiserfs_buffer_journaled/g %{PATCH80} | patch -p1 -s
%patch81 -p1
%endif

#sysv
%patch82 -p1

%patch83 -p1

#### HardWare Patch
#CPU
%patch101 -p1
%patch102 -p1
%patch103 -p1

#PCI
%patch106 -p1
%patch107 -p1
%patch108 -p1
%patch109 -p1

#SCSI
%patch111 -p1

cp dc395/*.[hc] drivers/scsi/
cp dc395/README.* Documentation/
patch -p1 -s < dc395/dc395-integ.diff
rm -fr dc395

%patch115 -p1
%patch117 -p1
%patch118 -p1
%patch119 -p1
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1
%patch126 -p1

#Hardware RAID
%patch131 -p1
%patch132 -p1
%patch133 -p1
%patch134 -p1
%patch135 -p1
%patch138 -p1
%patch139 -p1
%patch140 -p1

%patch116 -p1

#IDE
%patch136 -p1
%patch137 -p1

#Ethernet
tar zxf %{SOURCE32} -C drivers/net/
#tar zxf %{SOURCE33} -C drivers/net/
cp -f %{SOURCE34} drivers/net/
cp -f %{SOURCE35} drivers/net/
cp -f %{SOURCE36} drivers/net/old_via-rhine.c
tar zxf %{SOURCE37} -C drivers/net/

cp -f drivers/net/3c90x-*/3c90x.* drivers/net/
rm -rf drivers/net/3c90x-* 

mv -f drivers/net/sundance.c drivers/net/sundance_main.c
mv -f drivers/net/starfire.c drivers/net/starfire_main.c
%patch141 -p1

tar zxf %{SOURCE41}
cd userlink-*
  cp userlink.c ../drivers/net/
  cp linux/if_userlink.h ../include/linux/
cd ..
rm -fr userlink-*
%patch143 -p1
%patch144 -p3
%patch145 -p1
%patch146 -p1
%ifnarch i386 i586 i686
%patch147 -p1
%endif
%patch148 -p1
# CLModem
tar zxf %{SOURCE43} -C drivers/char
cp -af drivers/char/CLModem-*/*.c drivers/char
cp -af drivers/char/CLModem-*/*.h drivers/char
rm -rf drivers/char/CLModem-*
%patch272 -p1

#Sound

#alsa
cd alsa-driver-%{ALSAver}
%patch161 -p1
%patch162 -p0
cd ..

#Serial ( We move it before the damage ext3 kdb patch)

#Video
%ifarch i386 i586 i686
cd drivers/video
  mkdir -p i810-tmp
  cd i810-tmp
    tar zxf %{SOURCE42}
    cp agpgart.[hc] ..
    cp -f agpgart.h ../../../include/linux
  cd ..
  rm -fr i810-tmp
cd ../..
%patch176 -p1
%endif

%patch177 -p1
%patch178 -p1
%patch179 -p1

#I2O
%patch181 -p1
%patch182 -p1

#USB IEEE1394
%patch191 -p1
%patch192 -p1
%patch193 -p1
%patch194 -p1
%patch195 -p1
%patch196 -p1
%patch197 -p1

#PCMCIA
%ifarch i386 i586 i686 ppc
cd pcmcia-cs-%{pcmciaver}
chmod +w -R *
tar zxf %{SOURCE53}
tar zxf %{SOURCE54}
tar zxf %{SOURCE55}
tar zxf %{SOURCE56}

mv nsp_cs-%{ninjaver}/nsp_cs.[ch] clients/
mv nsp_cs-%{ninjaver}/nsp_io.c clients/
mkdir doc/nsp_cs
mv nsp_cs-%{ninjaver}/README.nsp_cs* doc/nsp_cs
mv nsp_cs-%{ninjaver}/Q_and_A.nsp_cs* doc/nsp_cs
mv nsp_cs-%{ninjaver}/nsp_cs.conf etc/
mv nsp_cs-%{ninjaver}/nsp_cs.4* man/
rm -rf nsp_cs-%{ninjaver}

mv lpc3tx-v1.00a/axnet_cs.c clients
mv lpc3tx-v1.00a/8390ax.h include
mv lpc3tx-v1.00a/readme doc/README.lpc3tx
mv lpc3tx-v1.00a/readme.jp doc/README.lpc3tx.jp
mv lpc3tx-v1.00a/config.lpc3 etc/lpc3.conf
rm -rf lpc3tx-v1.00a

%patch201 -p1
%patch202 -p1
%patch203 -p1
%patch204 -p1
%patch205 -p0
%patch206 -p1
%patch207 -p1
%patch208 -p0
%patch209 -p1
%patch210 -p1
%patch211 -p1
cd ..
%else
rm -rf pcmcia-cs-%{pcmciaver}
rm -rf ibcs
%endif


#Misc
%patch271 -p1
%patch273 -p1
%patch274 -p1
%patch280 -p1
%patch281 -p1
%patch282 -p1

#### other platform
#PPC
%ifarch ppc
#%patch341 -p0
%endif

#S390
%ifarch s390
%patch361 -p1
%patch362 -p1
%endif

%ifarch i386 i586 i686
#Async IO
%if %{ASYNC}
%patch41 -p1
%patch42 -p0
%endif

cp -f ibcs/CONFIG.i386 ibcs/CONFIG
%endif

#Mirale
%patch500 -p1
%patch501 -p1

install -m644 %{SOURCE13} .

# Basically, this sucks. Shipping kernel source with procompiled binaries,
# that is. And having 'make mrproper' not cleaning that up either
make clean -C scripts/ksymoops

%ifarch i386 i586 i686 ppc
# replace PCMCIA scripts
install -m755 %{SOURCE50} pcmcia-cs-%{pcmciaver}/etc/network
# additional TL config
cat %{SOURCE52} >> pcmcia-cs-%{pcmciaver}/etc/config.opts
%endif

# make sure the kernel has the sublevel we know it has...
perl -p -i -e "s/^SUBLEVEL.*/SUBLEVEL = %{sublevel}/" Makefile
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}/" Makefile

# get rid of unwanted files
find . -name "*.orig" -exec rm -f {} \;
find . -name "*~" -exec rm -f {} \;
make mrproper
%ifarch i386 i586 i686
cp -f %{SOURCE20} arch/i386/defconfig
%endif
%ifarch alpha
cp -f %{SOURCE21} arch/%{_arch}/defconfig
%endif
make include/linux/version.h

# --------------------------------------------------------------------

%build

%ifarch i386 i586 i686
function enableFeature {
  echo >> arch/i386/defconfig
  for i in $*
  do
    echo $i=y >> arch/i386/defconfig
  done
}

function disableFeature {
  echo >> arch/i386/defconfig
  for i in $*
  do
    echo \# $i is not set >> arch/i386/defconfig
  done
}
%else
function enableFeature {
  echo >> arch/%{_arch}/defconfig
  for i in $*
  do
    echo $i=y >> arch/%{_arch}/defconfig
  done
}

function disableFeature {
  echo >> arch/%{_arch}/defconfig
  for i in $*
  do
    echo \# $i is not set >> arch/%{_arch}/defconfig
  done
}
%endif

function buildKernel {
  type=$1  
  if [ -z "$type" -o "$type" = "up" ]
  then
    type=
    Config=%{_target_cpu}
    KernelVer=%{version}-%{release}
    echo Building the kernel for uni processor ...
  else
    Config=%{_target_cpu}-$type
    KernelVer=%{version}-%{release}$type
    echo Building the kernel for $type ...
  fi
  %ifarch i386 i586 i686
    HOSTCC=%{COMPILER} CC=%{COMPILER}
    export HOSTCC CC
    cp -f %{SOURCE20} arch/i386/defconfig
  %endif
  %ifarch alpha
    cp -f %{SOURCE21} arch/%{_arch}/defconfig
  %endif
  %ifarch s390
  if [ "$type" = "IPLvrdr" ]
  then
     cp -f %{SOURCE22} arch/%{_arch}/defconfig
  else
     cp -f %{SOURCE23} arch/%{_arch}/defconfig
  fi
  %endif

# ------------------------------------------------------------------
%ifarch i386 i586 i686
    if [ ! "$type" = "BOOT" ]; then
%if %{ASYNC}
      enableFeature CONFIG_AIO
      echo "CONFIG_AIO_MAX=4096" >> arch/i386/defconfig
%endif
      echo
    fi
%if %{BIGMEM}
    enableFeature CONFIG_BIGMEM
    need_bigmem=t
%endif

%endif
# ------------------------------------------------------------------
  %ifarch i386 i586 i686
      disableFeature CONFIG_MATH_EMULATION
  %endif
  %ifarch i586
      enableFeature CONFIG_M586
  %endif
  %ifarch i686
      enableFeature CONFIG_M686
  %endif
  # ------------------------------------------------------------------
  if [ "$type" = "BOOT" ] || [ "$type" = "smpBOOT" ]; then
    disableFeature \
	CONFIG_MODVERSIONS \
	CONFIG_MTRR CONFIG_KMOD CONFIG_BSD_PROCESS_ACCT \
	CONFIG_BINFMT_AOUT CONFIG_BINFMT_MISC CONFIG_APM CONFIG_PNP \
	CONFIG_BLK_DEV_IDEDMA CONFIG_BLK_DEV_ALI15X3 CONFIG_BLK_DEV_AMD7409 \
	CONFIG_BLK_DEV_CMD64X CONFIG_BLK_DEV_CS5530 CONFIG_BLK_DEV_PIIX \
	CONFIG_BLK_DEV_AEC62XX \
	CONFIG_BLK_DEV_SIS5513 CONFIG_BLK_DEV_NBD CONFIG_BLK_DEV_XD \
	CONFIG_BLK_DEV_HPT34X CONFIG_BLK_DEV_HPT366 CONFIG_BLK_DEV_SLC90E66 \
	CONFIG_BLK_DEV_PDC202XX CONFIG_BLK_DEV_OSB4 CONFIG_IDEDMA_IVB \
	CONFIG_NETLINK CONFIG_FIREWALL CONFIG_IP_MULTICAST \
	CONFIG_FILTER CONFIG_SYN_COOKIES CONFIG_SCSI_LOGGING \
	CONFIG_IP_ALIAS CONFIG_INET_RARP CONFIG_SKB_LARGE CONFIG_IPV6 \
	CONFIG_IP_TRANSPARENT_PROXY CONFIG_IP_MASQUERADE \
	CONFIG_IPX CONFIG_ATALK CONFIG_WAN_ROUTER \
	CONFIG_NET_SCHED CONFIG_PHONE CONFIG_PHONE_IXJ CONFIG_FDDI \
	CONFIG_ISDN CONFIG_SERIAL_EXTENDED CONFIG_SERIAL_NONSTANDARD \
	CONFIG_JOYSTICK CONFIG_WATCHDOG CONFIG_NVRAM CONFIG_I2C CONFIG_RTC \
	CONFIG_VIDEO_DEV CONFIG_DTLK CONFIG_FTAPE CONFIG_QUOTA \
	CONFIG_BSD_DISKLABEL CONFIG_MAC_PARTITION CONFIG_SMD_DISKLABEL \
	CONFIG_SOLARIS_X86_PARTITION CONFIG_UNIXWARE_DISKLABEL \
	CONFIG_NLS CONFIG_MAGIC_SYSRQ 

    enableFeature CONFIG_ISO9660_FS CONFIG_NFS_FS \
		  CONFIG_BLK_DEV_SR CONFIG_BLK_DEV_IDEFLOPPY
  else
    enableFeature CONFIG_BLK_DEV_LVM CONFIG_EXT3_FS CONFIG_REISERFS_FS
  fi
  if [ "$type" = "smp" ]; then
    enableFeature CONFIG_SMP
  fi
  rm -f .config
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{release}$type/" Makefile
%ifarch i386 i586 i686
  HOSTCC=%{COMPILER} CC=%{COMPILER}
  export HOSTCC CC
%endif
  make mrproper
  make oldconfig
  cp -f .config configs/kernel-$KernelVer-%{_target_cpu}.config
  make dep
  make include/linux/version.h 
  if [ -x /usr/bin/getconf ] ; then
    nrproc=$(/usr/bin/getconf _NPROCESSORS_ONLN)
    if [ $nrproc -eq 0 ] ; then
      nrproc=1
    fi
  else
    nrproc=1
  fi
%ifarch i386 i586 i686
  make bzImage MAKE="make -j $nrproc"
%endif
%ifarch ppc
  for i in boot chrpboot coffboot mbxboot; do \
      cp -a $RPM_SOURCE_DIR/ramdisk.image.gz-ppc arch/ppc/$i/ramdisk.image.gz
  done
  make vmlinux zImage zImage.initrd MAKE="make -j $nrproc"
%endif
%ifarch alpha sparc sparc64
  make boot MAKE="make -j $nrproc"
%endif

%ifarch s390
  make image MAKE="make -j $nrproc"
%endif

# emu10k1 audio.o alrady made why?
  rm -f drivers/sound/emu10k1/audio.o  

  make modules MAKE="make -j $nrproc"
  # first make sure we are not loosing any .ver files to make mrporper's
  # removal of zero sized files.
  find include/linux/modules -size 0 | while read file ; do \
    echo > $file
  done
  # Start installing stuff
  mkdir -p $RPM_BUILD_ROOT/boot
  install -m 644 System.map $RPM_BUILD_ROOT/boot/System.map-$KernelVer
  install -m 644 %{SOURCE11} $RPM_BUILD_ROOT/boot/module-info-$KernelVer
%ifarch i386 i586 i686
  cp arch/i386/boot/bzImage $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
  cp vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
%endif
%ifarch alpha ppc sparc sparc64
  gzip -cfv vmlinux > vmlinuz
  install -m 755 vmlinux $RPM_BUILD_ROOT/boot/vmlinux-$KernelVer
  install -m 644 vmlinuz $RPM_BUILD_ROOT/boot/vmlinuz-$KernelVer
  %ifarch ppc
    install -m 644 arch/ppc/chrpboot/zImage $RPM_BUILD_ROOT/boot/zImage-$KernelVer
    install -m 644 arch/ppc/chrpboot/zImage.initrd $RPM_BUILD_ROOT/boot/zImage.initrd-$KernelVer
  %endif
%endif
%ifarch s390
  install -m 755 arch/s390/boot/image $RPM_BUILD_ROOT/boot/image-$KernelVer
%endif

  make INSTALL_MOD_PATH=$RPM_BUILD_ROOT modules_install KERNELRELEASE=$KernelVer
  rm -f $RPM_BUILD_ROOT/lib/modules/$KernelVer/build
  install -m644 %{SOURCE65} $RPM_BUILD_ROOT/lib/modules/$KernelVer/pcimodules.dat
%ifnarch sparc64
  cc -o rhkmvtag rhkmvtag.c init/version.o
  ./rhkmvtag > $RPM_BUILD_ROOT/lib/modules/$KernelVer/.rhkmvtag
  rm -f rhkmvtag
%endif

%if %{UNICON}
  CCFLAGS='CC=gcc'
%ifarch i386 i586 i686
  CCFLAGS='CC=%{COMPILER}'
%endif
  if [ "$type" = "smp" ] || [ "$type" = "smpBOOT" ]; then
    CCFLAGS="$CCFLAGS -D__SMP__"
  fi
  export CCFLAGS
  cd unicon*
  make clean -C unikey
  make clean -C fonts
  make -C unikey "$CCFLAGS"
  make -C fonts "$CCFLAGS"
  mkdir -p $RPM_BUILD_ROOT/lib/modules/$KernelVer/misc
  install -m644 unikey/unikey.o $RPM_BUILD_ROOT/lib/modules/$KernelVer/misc
  install -m644 fonts/big5/encode-big5.o fonts/gb/encode-gb.o fonts/gbk/encode-gbk.o fonts/jis/encode-jis.o fonts/kscm/encode-kscm.o $RPM_BUILD_ROOT/lib/modules/$KernelVer/misc
  cd ..
%endif

%ifarch i386 i586 i686
  if [ -f $RPM_SOURCE_DIR/fasttrak-1.20b2.tar.gz ]; then
    tar zxf $RPM_SOURCE_DIR/fasttrak-1.20b2.tar.gz
    make TOPDIR=$RPM_BUILD_DIR/linux -C relb2
    install -m644 relb2/ft.o $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/block/
    rm -rf relb2
  fi
%endif
}

function buildPCMCIA {
  bigmem=""
  if [ "$need_bigmem" = "t" ]; then
    bigmem="-DCONFIG_BIGMEM"
  fi
  cd pcmcia-cs-%{pcmciaver}
    make clean
%ifarch i386 i586 i686
    export CC=%{COMPILER}
%endif
    ./Configure \
    --noprompt --cc=${CC} --kflags="$bigmem -fno-strength-reduce"\
    --kernel=$RPM_BUILD_DIR/linux \
    --target=$RPM_BUILD_ROOT \
    --moddir=/lib/modules/%{KVERREL}$1 \
    --trust --cardbus --nopnp \
    --srctree --sysv --rcdir=/etc/rc.d
    make all
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/pcmcia
    make install PREFIX=$RPM_BUILD_ROOT MANDIR=$RPM_BUILD_ROOT%{_mandir}

    cd linux-wlan-ng-*
%ifarch i386 i586 i686
    export HOST_CC=%{COMPILER}
    ARCH=i386
%else
    ARCH=ppc
%endif

    ./Configure << _EOF_
$RPM_BUILD_DIR/linux
$RPM_BUILD_DIR/linux/pcmcia-cs-%{pcmciaver}
$RPM_BUILD_ROOT
/lib/modules/%{KVERREL}$1
/etc/pcmcia
sta
$ARCH

n
n
n
_EOF_
    make all install clean
    rm -f config.out
    cd ..

    if [ "$1" = "" ]; then
      cd wireless_tools.*
      make CFLAGS="-O2 -Wall -I../../include"
      install -s -m755 iwconfig iwpriv iwspy $RPM_BUILD_ROOT/sbin
      install -m644 iwconfig.8 iwpriv.8 iwspy.8 $RPM_BUILD_ROOT%{_mandir}/man8
      make clean
      cd ..
    fi

    if [ "$1" = "BOOT" ]; then
      cd cardmgr
      make clean
      make LIBCARDMGR=1 all
      mkdir -p $RPM_BUILD_ROOT/usr/lib
      install -m644 libcardmgr.a $RPM_BUILD_ROOT/usr/lib
      cd ..
    fi
  cd ..
}

function buildiBCS() {
    SMP=no
    if [ "$1" = "smp" ]; then
	SMP=yes
    fi
    make -j $nrproc -C ibcs/iBCSemul KERNEL=$RPM_BUILD_DIR/linux SMP=$SMP all
    install -m644 ibcs/iBCSemul/iBCS \
	$RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/misc/iBCS.o
    make -C ibcs clean
}

function buildALSA() {
    CC=%{COMPILER}; export CC
    cd alsa-driver-%{ALSAver}

    CFLAGS="$RPM_OPT_FLAGS" ./configure --prefix=/usr \
    --with-kernel=$RPM_BUILD_DIR/linux \
    --with-moddir=/lib/modules/%{KVERREL}$1/misc --with-sequencer=yes \
    --with-isapnp=yes --with-oss=yes --with-cards=all

    make clean
    make
    make install prefix=$RPM_BUILD_ROOT/usr \
    moddir=$RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/misc

    cd ..
}

function buildEXTRA() {
%ifarch i386 i586 i686
    export CC=%{COMPILER}
%endif
    mkdir -p $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/extra
# pctel
PCTEL=hsp56-linux-1.tar.gz
    if [ -f ${RPM_SOURCE_DIR}/${PCTEL} ]; then
        tar zxf ${RPM_SOURCE_DIR}/${PCTEL}
        make -C hsp56-linux-1/src/module CC="$CC -D__KERNEL__ -DMODULE -Wall -O -fomit-frame-pointer -I../../../include/"
	install -m644 hsp56-linux-1/lib/pctel.o $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/extra/
	rm -rf hsp56-linux-1
    fi

# Equinox
    if [ -f $RPM_SOURCE_DIR/eqnx3-36.tar.gz ]; then
	tar zxf $RPM_SOURCE_DIR/eqnx3-36.tar.gz
	make eqnx.o -C eqnx3-36
	install -m644 eqnx3-36/eqnx.o $RPM_BUILD_ROOT/lib/modules/%{KVERREL}$1/extra/
	rm -rf eqnx3-36
    fi
}

function saveHeaders() {
    # deal with the kernel headers that are version specific
    mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux
    if [ -n "$1" ] ; then
    	install -m 644 include/linux/autoconf.h \
	    $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/autoconf-$1.h
    	install -m 644 include/linux/version.h \
	    $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/version-$1.h
	sed -e "s,/modules/,/modules-$1/,g" < include/linux/modversions.h > \
	    $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/modversions-$1.h
	mv include/linux/modules include/linux/modules-$1
	
    fi
}

rm -rf $RPM_BUILD_ROOT/

%ifarch s390
buildKernel IPLtape
saveHeaders IPLtape

buildKernel IPLvrdr
saveHeaders IPLvrdr

%else # not s390

# SMP kernel
buildKernel smp
%ifarch i386 i586 i686 ppc
  buildPCMCIA smp
%endif
%ifarch i386 i586 i686
  buildiBCS smp
  buildALSA smp
  buildEXTRA smp
%endif
saveHeaders smp

# BOOT kernel
%ifnarch i686
  buildKernel BOOT
%ifarch i386 i586 i686 ppc
  buildPCMCIA BOOT
%endif
%ifarch i386 i586
  buildALSA BOOT
%endif
  saveHeaders BOOT
%ifarch alpha
  buildKernel smpBOOT
  saveHeaders smpBOOT
%endif
%endif

# Uni processor kernel
buildKernel
%ifarch i386 i586 i686 ppc
  buildPCMCIA
%endif
%ifarch i386 i586 i686
  buildiBCS
  buildALSA
  buildEXTRA
%endif
saveHeaders up

%endif # else not s390

make -C ksymoops-%{ksymoopsver}

# --------------------------------------------------------------------

%install

mkdir -p $RPM_BUILD_ROOT/boot
mkdir -p $RPM_BUILD_ROOT/sbin
FILE=`file $RPM_BUILD_ROOT/sbin/* | grep ELF | awk -F: '{ print $1 }'`
if [ ! "$FILE" = "" ]; then
  strip $FILE
fi

install -m 755 %{SOURCE12} $RPM_BUILD_ROOT/sbin/installkernel

%ifarch i386 i586 i686
install -m 755 alsa-driver-%{ALSAver}/snddevices $RPM_BUILD_ROOT/sbin/snddevices
# additional TL config
install -m644 %{SOURCE51} $RPM_BUILD_ROOT/etc/pcmcia/tladd.conf
chmod 644 $RPM_BUILD_ROOT/etc/pcmcia/*.opts

rm -rf $RPM_BUILD_ROOT/dev/*
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man9
install -m 644 ibcs/Doc/iBCS.9 $RPM_BUILD_ROOT%{_mandir}/man9

mkdir -p $RPM_BUILD_ROOT/dev/inet
install -m755 ibcs/MAKEDEV.ibcs $RPM_BUILD_ROOT/dev

(cd $RPM_BUILD_ROOT
  mknod ./dev/socksys c 30 0
  ln -s socksys ./dev/nfsd
  ln -s null ./dev/X0R

  mknod ./dev/agpgart c 10 175
  chmod go+w ./dev/agpgart
  mknod --mode=666 ./dev/ttyS15 c 62 79
%if UNICON
  mknod ./dev/unikey c 10 202
%endif
  mknod ./dev/watchdog c 10 130
  mknod ./dev/spx c 30 1
  mknod ./dev/inet/ip c 30 32
  mknod ./dev/inet/icmp c 30 33
  mknod ./dev/inet/ggp c 30 34
  mknod ./dev/inet/ipip c 30 35
  mknod ./dev/inet/tcp c 30 36
  mknod ./dev/inet/egp c 30 37
  mknod ./dev/inet/pup c 30 38
  mknod ./dev/inet/udp c 30 39
  mknod ./dev/inet/idp c 30 40
  mknod ./dev/inet/rawip c 30 41
  ln -s udp ./dev/inet/arp
  ln -s udp ./dev/inet/rip
  cd ./dev/inet
  for i in *; do
    ln -s inet/$i ../$i
  done
)

%if %{ASYNC}
mkdir -p $RPM_BUILD_ROOT/lib
cd libdba
%{COMPILER} -shared -o$RPM_BUILD_ROOT/lib/libdba.so -I. -I../include aiolib.c
cd ..
%endif
%endif #ifarch i386 i586 i686

# makedev usb
install -m755 %{SOURCE64} $RPM_BUILD_ROOT/dev
TOPDIR=$RPM_BUILD_ROOT $RPM_BUILD_ROOT/dev/`basename %{SOURCE64}`
%{COMPILER} -s %{SOURCE66} -o $RPM_BUILD_ROOT/sbin/usbdet
# makedev 1394
mknod -m 600 $RPM_BUILD_ROOT/dev/raw1394 c 171 0
mknod -m 666 $RPM_BUILD_ROOT/dev/video1394 c 172 0

%ifarch i686 sparc64
# these don't need much
exit 0
%endif

# headers
%ifarch i386 i586
# there is alsa header .
cp -a $RPM_BUILD_ROOT/usr/include/linux/* include/linux
%endif
rm -rf $RPM_BUILD_ROOT/usr/include/linux
mkdir -p $RPM_BUILD_ROOT/usr/include
ln -sf ../src/linux/include/linux $RPM_BUILD_ROOT/usr/include/linux

%ifarch sparc
ln -s ../src/linux/include/asm-sparc $RPM_BUILD_ROOT/usr/include/asm-sparc
ln -s ../src/linux/include/asm-sparc64 $RPM_BUILD_ROOT/usr/include/asm-sparc64
mkdir $RPM_BUILD_ROOT/usr/include/asm
cp -a $RPM_SOURCE_DIR/kernel-2.2-BuildASM.sh $RPM_BUILD_ROOT/usr/include/asm/BuildASM
$RPM_BUILD_ROOT/usr/include/asm/BuildASM $RPM_BUILD_ROOT/usr/include
%else
ln -sf ../src/linux/include/asm $RPM_BUILD_ROOT/usr/include/asm
%endif

# sources
mkdir -p $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION} 
tar cf - . | tar xf - -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
ln -sf linux-%{PACKAGE_VERSION} $RPM_BUILD_ROOT/usr/src/linux
install -m 644 %{SOURCE60} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
install -m 644 %{SOURCE61} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
install -m 644 %{SOURCE62} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
install -m 644 %{SOURCE63} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}

#clean up the destination
%ifarch i386 i586
make clean -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/pcmcia-cs-%{pcmciaver}
rm -f $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/pcmcia-cs-%{pcmciaver}/config.out
rm -f $RPM_BUILD_ROOT/etc/pcmcia/*.conf.opts
chmod 755 $RPM_BUILD_ROOT/etc/rc.d/init.d/pcmcia
make -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/ibcs clean
%endif

make mrproper -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
make oldconfig -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
make symlinks -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
make include/linux/version.h -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}

#this generates modversions info which we want to include and we may as
#well include the depends stuff as well, after we fix the paths
HOSTCC=%{COMPILER} make depend -C $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}
find $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION} -name ".*depend" | \
while read file ; do
    mv $file $file.old
    sed -e "s|[^ ]*\(/usr/src/linux\)|\1|g" < $file.old > $file
    rm -f $file.old
done

# Try to put some smarter autoconf.h and version.h files in place
install -m 644 %{SOURCE15} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/autoconf.h
install -m 644 %{SOURCE16} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/version.h
install -m 644 %{SOURCE17} $RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/include/linux/modversions.h
> $RPM_BUILD_ROOT/boot/kernel.h

# other tools
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT%{_mandir}/man8
install -m755 -s ksymoops-%{ksymoopsver}/ksymoops $RPM_BUILD_ROOT/usr/bin/
install -m644 ksymoops-%{ksymoopsver}/ksymoops.8 $RPM_BUILD_ROOT%{_mandir}/man8
%ifarch i386 i586
install -m755 %{SOURCE10} \
	$RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/SetupKernelSource.sh
perl -p -i -e "s/\@release\@/%{release}/" \
	$RPM_BUILD_ROOT/usr/src/linux-%{PACKAGE_VERSION}/SetupKernelSource.sh
%endif

# --------------------------------------------------------------------
%clean
rm -rf $RPM_BUILD_ROOT

# --------------------------------------------------------------------
###
### scripts
###

%pre
/sbin/modprobe loop 2> /dev/null > /dev/null
exit 0

%pre smp
/sbin/modprobe loop 2> /dev/null > /dev/null
exit 0

%post
cd /lib/modules
if [ -L %{PACKAGE_VERSION} ]; then
  rm -f %{PACKAGE_VERSION}
fi
ln -sf %{KVERREL} %{PACKAGE_VERSION}
cd /boot
ln -sf vmlinuz-%{KVERREL} vmlinuz
ln -sf System.map-%{KVERREL} System.map
ln -sf module-info-%{KVERREL} module-info
if [ -e initrd ] || [ -L initrd ]; then
  if [ -x /sbin/mkinitrd ]; then
    /sbin/mkinitrd -f initrd-%{KVERREL} %{KVERREL}
    ln -sf initrd-%{KVERREL} initrd
  fi
fi
%ifarch i386 i586 i686
if [ -x /sbin/lilo -a -e /etc/lilo.conf ]; then
  /sbin/lilo > /dev/null 2>&1
fi
/sbin/chkconfig --add alsasound
/sbin/snddevices 1> /dev/null 2> /dev/null
%if %{ASYNC}
/sbin/ldconfig
%endif
CONF="/etc/modules.conf"
AGPGART="alias char-major-10-175 agpgart"
if [ -f /proc/bus/pci/devices ]; then
    cat /proc/bus/pci/devices | awk '{ print $2 }' | \
    grep -qs -e 80867121 -e 80867123 -e 80867125 -e 80861132
    if [ $? = 0 ]; then
	grep -qs "^$AGPGART" $CONF || echo $AGPGART >> $CONF
    fi
fi
%endif # i386 i586 i686
%ifarch alpha
cp vmlinuz-%{KVERREL} vmlinux.gz
%endif
grep -qs ^path $CONF || grep -qs ^keep $CONF || echo keep >> $CONF
grep -qs "^path\[usb\]" echo "path[usb]=/lib/modules/\`uname -r\`" >> $CONF
exit 0

%post smp
cd /lib/modules
if [ -L %{PACKAGE_VERSION} ]; then
  rm -f %{PACKAGE_VERSION}
fi
ln -sf %{KVERREL}smp %{PACKAGE_VERSION}
cd /boot
ln -sf vmlinuz-%{KVERREL}smp vmlinuz
ln -sf System.map-%{KVERREL}smp System.map
ln -sf module-info-%{KVERREL}smp module-info
if [ -e initrd ] || [ -L initrd ]; then
  if [ -x /sbin/mkinitrd ]; then
    /sbin/mkinitrd -f initrd-%{KVERREL}smp %{KVERREL}smp
    ln -sf initrd-%{KVERREL}smp initrd
  fi
fi
%ifarch i386 i586 i686
if [ -x /sbin/lilo -a -e /etc/lilo.conf ]; then
  /sbin/lilo > /dev/null 2>&1
fi
%endif
%ifarch alpha
cp vmlinuz-%{KVERREL} vmlinux.gz
%endif
exit 0

%preun
rm -f /lib/modules/%{KVERREL}/modules.*
rm -f /boot/initrd-%{KVERREL}
rm -f /lib/modules/%{PACKAGE_VERSION} 1>/dev/null 2>/dev/null
if [ "$1" = 0 ] ; then
  /sbin/chkconfig --del alsasound
fi
exit 0

%preun smp
rm -f /lib/modules/%{KVERREL}smp/modules.*
rm -f /boot/initrd-%{KVERREL}smp

%post headers
cd /usr/src
rm -rf linux
ln -snf linux-%{PACKAGE_VERSION} linux

%post source
cd /usr/src
rm -rf linux
ln -snf linux-%{PACKAGE_VERSION} linux

%postun
%if %{ASYNC} 
if [ $1 = 0 ]; then
  /sbin/ldconfig
fi
%endif

%postun headers
if [ -L /usr/src/linux ]; then
  if [ `ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{PACKAGE_VERSION}" ]; then
    [ $1 = 0 ] && rm -f /usr/src/linux
  fi
fi
exit 0

%postun source
if [ -L /usr/src/linux ]; then 
  if [ `/bin/ls -l /usr/src/linux | awk '{ print $11 }'` = "linux-%{PACKAGE_VERSION}" ]; then
    [ $1 = 0 ] && rm -f /usr/src/linux
  fi
fi
exit 0

%ifarch i386 i586 ppc
%post pcmcia-cs
PCIC=""
PCMCIA=`/sbin/probe | grep "TCIC-2 probe: not found"`

if [ "$PCMCIA" = "" ]; then
  /sbin/chkconfig --add pcmcia
  PCMCIA=yes
else
  PCMCIA=no
fi

if [ "$PCMCIA" = "yes" ] && [ ! -f /etc/sysconfig/pcmcia ]; then
  PCIC=`/sbin/probe | grep -v "not found" | grep PCI`
  if [ ! "$PCIC" = "" ]; then
    PCIC="i82365"
  else
    PCIC=`/sbin/probe | grep -v "not found" | grep TCIC-2`
    if [ ! "$PCIC" = "" ]; then
      PCIC="tcic"
    fi
  fi
fi

if [ ! -f /etc/sysconfig/pcmcia ]; then
  cat > /etc/sysconfig/pcmcia <<EOF
PCMCIA=$PCMCIA
PCIC=$PCIC
PCIC_OPTS=
CORE_OPTS=
EOF
fi
CONF="/etc/modules.conf"
grep -qs ^path $CONF || grep -qs ^keep $CONF || echo keep >> $CONF
grep -qs "^path\[pcmcia\]" $CONF || echo "path[pcmcia]=/lib/modules/\`uname -r\`" >> $CONF

%preun pcmcia-cs
if [ $1 = 0 ]; then
  /sbin/chkconfig --del pcmcia
  rm -f /etc/sysconfig/pcmcia
fi
%endif # i386 i586 ppc

%ifarch i386 i586 i686
%post extramodules
CONF="/etc/modules.conf"
grep -qs ^path $CONF || grep -qs ^keep $CONF || echo keep >> $CONF
grep -qs "^path\[extra\]" $CONF || echo "path[extra]=/lib/modules/\`uname -r\`" >> $CONF
%endif

# --------------------------------------------------------------------
###
### file lists
###

%ifarch s390
%files IPLtape
/boot/image-%{KVERREL}IPLtape
/boot/System.map-%{KVERREL}IPLtape
/boot/module-info-%{KVERREL}IPLtape
/lib/modules/%{KVERREL}IPLtape

%files IPLvrdr
/boot/image-%{KVERREL}IPLvrdr
/boot/System.map-%{KVERREL}IPLvrdr
/boot/module-info-%{KVERREL}IPLvrdr
/lib/modules/%{KVERREL}IPLvrdr

%endif

%ifarch i386 i586 i686 alpha sparc sparc64 ppc
%files
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}
/boot/vmlinuz-%{KVERREL}
/boot/System.map-%{KVERREL}
/boot/module-info-%{KVERREL}
%dir /lib/modules/%{KVERREL}
/lib/modules/%{KVERREL}/block
/lib/modules/%{KVERREL}/cdrom
/lib/modules/%{KVERREL}/fs
/lib/modules/%{KVERREL}/ipv4
/lib/modules/%{KVERREL}/ipv6
/lib/modules/%{KVERREL}/misc
/lib/modules/%{KVERREL}/net
/lib/modules/%{KVERREL}/scsi
/lib/modules/%{KVERREL}/video
/lib/modules/%{KVERREL}/usb
/lib/modules/%{KVERREL}/ieee1394
/lib/modules/%{KVERREL}/pcimodules.dat
%ifarch i386 i586 i686 ppc
/lib/modules/%{KVERREL}/pcmcia
%endif
%ifarch i386 i586 i686
%if %{ASYNC}
/lib/libdba.so
%endif
/sbin/snddevices
/etc/rc.d/init.d/alsasound
%if UNICON
/dev/unikey
%endif
%endif # i386 i586 i686
%ifarch i386 i586 i686 alpha
/sbin/installkernel
%endif
/dev/agpgart
/dev/usb
/dev/input
/dev/*1394
/dev/watchdog
/sbin/usbdet
%endif # i386 i586 i686 alpha sparc sparc64 ppc

%ifarch i386 i586 ppc
%files pcmcia-cs
%defattr(-,root,root)
/sbin/cardmgr
/sbin/cardctl
/sbin/ftl_check
/sbin/ftl_format
/sbin/ide_info
#/sbin/lspnp
#/sbin/setpnp
/sbin/pack_cis
/sbin/dump_cis
/sbin/ifport
/sbin/ifuser
/sbin/pcinitrd
/sbin/probe
/sbin/scsi_info
/sbin/iwconfig
/sbin/iwpriv
/sbin/iwspy
/sbin/nwepgen
/sbin/wlanctl-ng
/sbin/wland
%doc pcmcia-cs-%{pcmciaver}/doc/PCMCIA-HOWTO 
%doc pcmcia-cs-%{pcmciaver}/doc/PCMCIA-PROG
%doc pcmcia-cs-%{pcmciaver}/SUPPORTED.CARDS 
%doc pcmcia-cs-%{pcmciaver}/CHANGES 
%doc pcmcia-cs-%{pcmciaver}/COPYING 
%doc pcmcia-cs-%{pcmciaver}/README
%{_mandir}/man4/*
%{_mandir}/man5/*
%{_mandir}/man8/cardctl.8*
%{_mandir}/man8/cardmgr.8*
%{_mandir}/man8/dump_cis.8*
%{_mandir}/man8/ftl_check.8*
%{_mandir}/man8/ftl_format.8*
%{_mandir}/man8/ide_info.8*
%{_mandir}/man8/ifport.8*
%{_mandir}/man8/ifuser.8*
%{_mandir}/man8/pack_cis.8*
%{_mandir}/man8/pcinitrd.8*
%{_mandir}/man8/scsi_info.8*
#%{_mandir}/man8/lspnp.8*
#%{_mandir}/man8/setpnp.8*
%{_mandir}/man8/iwconfig.8*
%{_mandir}/man8/iwpriv.8*
%{_mandir}/man8/iwspy.8*
/etc/rc.d/init.d/pcmcia
%dir /etc/pcmcia
/etc/pcmcia/cis
/etc/pcmcia/config
/etc/pcmcia/ftl
/etc/pcmcia/ide
/etc/pcmcia/memory
/etc/pcmcia/network
/etc/pcmcia/parport
/etc/pcmcia/scsi
/etc/pcmcia/serial
/etc/pcmcia/shared
/etc/pcmcia/wireless
/etc/pcmcia/*.conf
/etc/pcmcia/wlan-ng
/etc/wlan
%config /etc/pcmcia/*.opts
%dir /var/lib/pcmcia
#/usr/share/pnp.ids
%endif # i386 i586 ppc

%ifarch i386 i586 i686 alpha sparc sparc64 ppc
%files smp
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}smp
/boot/vmlinuz-%{KVERREL}smp
/boot/System.map-%{KVERREL}smp
/boot/module-info-%{KVERREL}smp
%dir /lib/modules/%{KVERREL}smp
/lib/modules/%{KVERREL}smp/block
/lib/modules/%{KVERREL}smp/cdrom
/lib/modules/%{KVERREL}smp/fs
/lib/modules/%{KVERREL}smp/ipv4
/lib/modules/%{KVERREL}smp/ipv6
/lib/modules/%{KVERREL}smp/misc
/lib/modules/%{KVERREL}smp/net
/lib/modules/%{KVERREL}smp/scsi
/lib/modules/%{KVERREL}smp/video
/lib/modules/%{KVERREL}smp/usb
/lib/modules/%{KVERREL}smp/ieee1394
/lib/modules/%{KVERREL}smp/pcimodules.dat
%ifarch i386 i586 i686 ppc
/lib/modules/%{KVERREL}smp/pcmcia
%endif
%endif # i386 i586 i686 alpha sparc sparc64 ppc

%ifarch i386 i586 alpha sparc ppc
%files BOOT
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}BOOT
/boot/vmlinuz-%{KVERREL}BOOT
/boot/System.map-%{KVERREL}BOOT
/lib/modules/%{KVERREL}BOOT
%ifarch i386 i586
/usr/lib/libcardmgr.a
%endif
%endif

%ifarch alpha
%files BOOTsmp
%defattr(-,root,root)
/boot/vmlinux-%{KVERREL}smpBOOT
/boot/vmlinuz-%{KVERREL}smpBOOT
/boot/System.map-%{KVERREL}smpBOOT
/lib/modules/%{KVERREL}smpBOOT
%endif

%ifnarch i686 sparc64

# START BASE ARCHES ONLY
%ifarch i386 i586 alpha sparc ppc s390
%files source
%defattr(-,root,root)
%dir /usr/src/linux-%{PACKAGE_VERSION}
/usr/src/linux-%{PACKAGE_VERSION}/COPYING
/usr/src/linux-%{PACKAGE_VERSION}/CREDITS
/usr/src/linux-%{PACKAGE_VERSION}/Documentation
/usr/src/linux-%{PACKAGE_VERSION}/MAINTAINERS
/usr/src/linux-%{PACKAGE_VERSION}/Makefile
/usr/src/linux-%{PACKAGE_VERSION}/README
/usr/src/linux-%{PACKAGE_VERSION}/REPORTING-BUGS
/usr/src/linux-%{PACKAGE_VERSION}/Rules.make
%dir /usr/src/linux-%{PACKAGE_VERSION}/arch
%ifarch i386 i586
/usr/src/linux-%{PACKAGE_VERSION}/arch/i386
%else
/usr/src/linux-%{PACKAGE_VERSION}/arch/%{_arch}
%endif
%ifarch sparc
/usr/src/linux-%{PACKAGE_VERSION}/arch/sparc64
%endif
%dir /usr/src/linux-%{PACKAGE_VERSION}/configs
/usr/src/linux-%{PACKAGE_VERSION}/configs/*.config
/usr/src/linux-%{PACKAGE_VERSION}/drivers
/usr/src/linux-%{PACKAGE_VERSION}/fs
/usr/src/linux-%{PACKAGE_VERSION}/init
/usr/src/linux-%{PACKAGE_VERSION}/ipc
/usr/src/linux-%{PACKAGE_VERSION}/kernel
/usr/src/linux-%{PACKAGE_VERSION}/lib
/usr/src/linux-%{PACKAGE_VERSION}/mm
/usr/src/linux-%{PACKAGE_VERSION}/modules
/usr/src/linux-%{PACKAGE_VERSION}/net
/usr/src/linux-%{PACKAGE_VERSION}/scripts
%ifarch i386 i586 ppc
/usr/src/linux-%{PACKAGE_VERSION}/pcmcia-cs-%{pcmciaver}
%endif
%ifarch i386 i586
/usr/src/linux-%{PACKAGE_VERSION}/alsa-driver-%{ALSAver}
/usr/src/linux-%{PACKAGE_VERSION}/ibcs
/usr/src/linux-%{PACKAGE_VERSION}/SetupKernelSource.sh
%endif
/usr/src/linux-%{PACKAGE_VERSION}/README.kernel-sources
/usr/src/linux-%{PACKAGE_VERSION}/README.kernel-sources.zh_CN
/usr/src/linux-%{PACKAGE_VERSION}/README.kernel-sources.zh_TW.Big5
/usr/src/linux-%{PACKAGE_VERSION}/README.kernel-sources.ja_JP.eucJP
%if %{UNICON}
/usr/src/linux-%{PACKAGE_VERSION}/unicon*/fonts
/usr/src/linux-%{PACKAGE_VERSION}/unicon*/sfonts/genfont
/usr/src/linux-%{PACKAGE_VERSION}/unicon*/unikey
/usr/src/linux-%{PACKAGE_VERSION}/unicon*/include
%endif

%files headers
%defattr(-,root,root)
%dir /usr/src/linux-%{PACKAGE_VERSION}/include
%ifarch sparc
/sbin/installkernel
/usr/src/linux-%{PACKAGE_VERSION}/include/asm-sparc
/usr/src/linux-%{PACKAGE_VERSION}/include/asm-sparc64
/usr/include/asm-sparc
/usr/include/asm-sparc64
%else
%ifarch i386 i586
/usr/src/linux-%{PACKAGE_VERSION}/include/asm-i386
%else
/usr/src/linux-%{PACKAGE_VERSION}/include/asm-%{_arch}
%endif
%endif
/usr/src/linux-%{PACKAGE_VERSION}/include/asm
/usr/src/linux-%{PACKAGE_VERSION}/include/asm-generic
/usr/src/linux-%{PACKAGE_VERSION}/include/linux
/usr/src/linux-%{PACKAGE_VERSION}/include/net
/usr/src/linux-%{PACKAGE_VERSION}/include/scsi
/usr/src/linux-%{PACKAGE_VERSION}/include/video
/usr/include/asm
/usr/include/linux
/boot/kernel.h

%files utils
%defattr(-,root,root)
%doc scripts/ksymoops/README
/usr/bin/ksymoops
%{_mandir}/man8/ksymoops.8*

%files doc
%defattr(-,root,root)
%doc Documentation/*
%endif # i386 i586 alpha sparc ppc s390
# END BASE ARCHES ONLY
%endif # ! i686 sparc64

%ifarch i386 i586
%files ibcs
%defattr(-,root,root)
%doc ibcs/{README,RELEASE,CREDITS,Doc}
%{_mandir}/man9/iBCS.9*
/dev/MAKEDEV.ibcs
/dev/inet
/dev/socksys
/dev/nfsd
/dev/X0R
/dev/spx
/dev/arp
/dev/egp
/dev/ggp
/dev/icmp
/dev/idp
/dev/ip
/dev/ipip
/dev/pup
/dev/rawip
/dev/rip
/dev/tcp
/dev/udp
%endif # i386 i586

%ifarch i386 i586 i686
%files extramodules 
%dir /lib/modules/%{KVERREL}
%dir /lib/modules/%{KVERREL}smp
/lib/modules/*/extra
/dev/ttyS15
%endif

# --------------------------------------------------------------------
%changelog
* Tue Nov 19 2002 Yasuma Takeda <yasuma@miraclelinux.com>
- 13.3
- fix vulnerability in lcall(No.501)

* Wed Mar 13 2002 Tatsuo Ito <tito@miraclelinux.com>
- 13.2
- fix vulnerability in zlib library

* Mon Jan 7 2002 Go Taniguchi <go@turbolinux.co.jp>
- rel 13

* Thu Dec 27 2001 Go Taniguchi <go@turbolinux.co.jp>
- 12.1
- fixed i860-ioapic and athlon760mp patch, some Fujitsu SMP boxes have problem.

* Thu Dec 13 2001 Go Taniguchi <go@turbolinux.co.jp>
- 12
- update 3w-xxxx-1.02.00.008
- support Adaptec 5400S by aacraid
- dpt_i2o queue_depth fix for processer
- ips 4.80
- defxxx don't scan EISA cards if EISA bus not present
- added support pcmci-cs "KME KXLC005 CD-ROM"

* Wed Jul 4 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 11

* Mon Jun 25 2001 Go Taniguchi <go@turbolinux.co.jp>
- 10.9.2
- fixed via timer
- fixed ncr53c8xx pciid table in pcimodules.dat
- more support VIA C3, cache size and mtrr

* Tue Jun 5 2001 Go Taniguchi <go@turbolinux.co.jp>
- 10.9
- support Dual Athlon with AMD 760MP, 
-   this patch come from John Wiederhold <john.wiederhold@turbolinux.com>

* Sun Jun 3 2001 Go Taniguchi <go@turbolinux.co.jp>
- 10.8
- fixed some VIA chipsets, back port from 2.4
- added support corega Wireless LAN PCCA-11 by wlan-ng

* Tue May 29 2001 Go Taniguchi <go@turbolinux.co.jp>
- 10.7
- fixed intel P4 and Foster cache size detection
- fixed IOAPIC setup, support i860 for Dual Foster
- fixed scsi scanning of certain external raid chassis devices
- SMP e100 use PCI I/O for status in intr

* Thu May 10 2001 Go Taniguchi <go@turbolinux.co.jp>
- 10.6
- update cciss 1.0.3, support new Smart Array 5i/532 (0xoe11,0xb178)
- cpqarray security fix
- support some Sony DSC by usbstorage
- update e100-1.6.5
- update e1000-3.0.10

- 10.5
- update dpt_i2o 2.3.3 from Adaptec
- added support initio 850 by a100u2w.o

* Tue May 1 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 10.4
- added some patchs from Paul.Clements@SteelEye.com
-  aic7xxx: handles the case where the reset line is asserted for longer than a second
-  scsi reset and not_ready fix patch
-  SD_EXTRA_DEVS: 21 to 64 for SCSI/Fibre Channel devices

* Tue May 1 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 10.3
- update ips 4.72
- update DAC960 2.2.10
- update aic7xxx 5.1.34

* Fri Apr 27 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 10.2
- fixed meny security bugs
-  binfmt_misc, cpia, cpuid, msr, classifier, getsockopt, setsockopt,
-  shared mem, udp port, x86 copy_to/from_user

* Tue Apr 17 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 10.1
- fixed MediaGX booting
- update bttv-0.7.62

* Mon Apr 16 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 10
- skip 3 - 9 release. Syncronization with China kernel release No.

* Sun Apr 8 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 2.3
- added option nowayout in all watchdog drivers for OPS

* Fri Apr 6 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 2.2
- ptrace security bug, added patch
- fixed pcmcia wlan-ng
- added arm.2.2.18-1.turbo.patch

* Mon Mar 19 2001 Koushi Takahashi <koushi@turbolinux.co.jp>
- rel 2.1
- added I2C patch for bttv 8-)

* Wed Mar 14 2001 Go Taniguchi <go@turbolinux.co.jp>
- rel 2, this is the Jupitor kernel.
 
* Thu Mar 8 2001 Go Taniguchi <go@turbolinux.co.jp>
- update e100 1.5.5a , pcimodules.dat too

* Wed Mar 7 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.A
- debash
- update aic7xxx 5.1.33 with pcmcia apa1480 path
- update ips 4.50.05, this is only version No.
- update e100 1.4.21
- update e1000 2.6.6
- some ide config change
- short bdflush times
- ext3 default option use journal

* Thu Mar 06 2001 Andreas Dilger <adilger@turbolabs.com>
- 1.9.1
- update ext3 to 0.0.6b

* Mon Mar 5 2001 Go Taniguchi <go@turbolinux.co.jp>
- fixed %post and %files
- refixed vga16fb ati moblity huck

* Sat Mar 3 2001 Go Taniguchi <go@turbolinux.co.jp>
- update unicon 3.0.2

* Fri Mar 2 2001 Go Taniguchi <go@turbolinux.co.jp>
- 8139too unused debug option delete

* Wed Feb 28 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.9
- fixed usb.c and usb-ohci.c
- added e100 compat options
- pcmcia-tl.conf, added some corega cards and remove nin_cs
- turn on CONFIG_REISERFS_FS for up and smp kernel
- module CONFIG_MINIX_FS BOOT kernel
- vga16fb ati moblity huck, not perfect yet
- turn on CONFIG_PRINTER_READBACK

* Wed Feb 28 2001 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- added textutils to PreReq to satisfy require

* Wed Feb 21 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.8
- nfs backport ac13 and aa1
- update qla2x00.c 4.15 Beta 

* Fri Feb 16 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.7
- added security fix sysctl.patch

* Thu Feb 15 2001 Go Taniguchi <go@turbolinux.co.jp>
- fixed pcmcia pci_fixup for Intel MX

* Fri Feb 9 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.6
- added old_e100, It version 1.2.1
- make atyfb module
- ServerWorks OSB4 driver have ploblem on Compaq, turn off

* Wed Feb 7 2001 Go Taniguchi <go@turbolinux.co.jp>
- added usbdet, usb detection progrum
- If only 1 CPU Detected, switching to non APIC mode.

* Wed Jan 31 2001 Go Taniguchi <go@turbolinux.co.jp>
- ext3 modules symbol fix from kiichiro

* Sun Jan 28 2001 Go Taniguchi <go@turbolinux.co.jp>
- added wlan-ng-0.1.7
- change unicon tarball
- update starfire.c v1.04, sundance.c v1.01a
- fixed sundance PCIID
- fixed usb-uhci-timeout
- remove usb enable patch
- usb jp106 keycode fixed

* Thu Jan 25 2001 Go Taniguchi <go@turbolinux.co.jp>
- 1.2
- update pcmcia-cs-3.1.24
- remove pcmcia-cs-3.1.4-xircom.patch, it include new pcmcia-cs
- update pcmcia ninja nsp_cs-1.1.4
- added pcmcia lpc3tx-v1.00a
- update alsa-driver-0.5.10b
- BOOT turn off CONFIG_BLK_DEV_PDC202XX CONFIG_BLK_DEV_OSB4 CONFIG_IDEDMA_IVB
- BOOT turn off CONFIG_FILTER CONFIG_SYN_COOKIES CONFIG_SCSI_LOGGING
- BOOT turn on CONFIG_BLK_DEV_IDEFLOPPY for LS120
- sundance.o and starfire.o dose not need pci-scan.o, now linked.
- 3c90x.o loading warn parameters fixed.

* Wed Jan 17 2001 SL Baur  <steve@turbolinux.co.jp>
- build on alpha

* Wed Jan 17 2001 Andreas Dilger <adilger@turbolinux.com>
- 1.1
- add LFS support to ext3
- fix ext3 checks for setting ext2 attributes

* Tue Jan 9 2001 Go Taniguchi <go@turbolinux.co.jp>
- release 1
- return on async
- added patch usb-storage-RATOC_CFreader.diff for some digital cameras
- change pctel source
- update dpt_i2o 1.14
- update pcimodules.dat

* Tue Jan 9 2001 Go Taniguchi <go@turbolinux.co.jp>
- 0.8
- update alsa-driver-0.5.10a

* Thu Jan 04 2001 Andreas Dilger <adilger@turbolinux.com>
- 0.7
- fix reiserfs to not use divide/mod on i_size (long long)
- update ext3 to 0.0.5e
- patch sysv to not use mod on i_size (long long)

* Mon Jan 1 2001 Go Taniguchi <go@turbolinux.co.jp>
- 0.6
- update reiserfs-3.5.29
- update ide.2.2.18.1221
- added ieee1394-2.2.18-20001223 patch
- added ieee1394 sbp2 driver
- added ieee1394 device files
- re turn on CONFIG_AGP and CONFIG_DRM 
-  kernel original agpgart rename to agpgart2, 
-  if you use X-4, please add or edit "alias char-major-10-175 agpgart2" in /etc/modules.conf
- added old_via-rhine.o, this version is 1.02b.
- modified files list and install section  for usb and ieee1394

* Thu Dec 28 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.5
- backport agpgart for XFree86-3.3.6 compat, turn off CONFIG_AGP and CONFIG_DRM
- sunrpc-clnt-too_small noizy, KERN_WARNING to KERN_NOTICE

* Sat Dec 23 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.4
- added sundance and starfire from becker's.
- update nic drivers via-rhine-1.08b-LK1.0.0 and tulip
- turn on CONFIG_SCSI_CPQFCTS.
- fixed kernel-2.2.18-i386.config many.
- update pcmcia-cs 3.1.23 and fixed tulip_cb for AMD COMET
- added usb keybord patch in unicon-kernel-2.2.18.patch
- added /lib/modules/%{KVERREL}/pcimodules.dat for turboprobe
- small fix i2opci-rade.patch for new megaraid

* Sat Dec 23 2000 Andreas Dilger <adilger@turbolinux.com>
- linux-2.2.18-loop-F1.patch: use ">> BLOCK_SIZE_BITS" not "/ BLOCK_SIZE"
-        because we don't want long long divide (gcc 2.7.2.3 complains),
-        don't #define BUG() macro if it is already defined
- rootfs-postext3-2.2.18.patch: update to match Tigran's 2.4.0 patch, which
-       will likely make it into the 2.4 kernel
- unicon-kernel-2.2.18-0.2.patch: move #ifdef CONFIG_UNICON before variable
-       declaration (doesn't compile if patch applied, but no CONFIG_UNICON)
- ext3-aed.diff, linux-2.2.18-ext2compat.diff: cosmetic changes

* Mon Dec 18 2000 Go Taniguchi <go@turbolinux.co.jp>
- added new irda patch

* Mon Dec 18 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 0.3
- update 2.2.18aa2
- update userlink-0.99c
- added support cpuid, New Athlon, mP6, Crusoe
- added support i815 agpgart

* Fri Dec 15 2000 Andreas Dilger <adilger@turbolinux.com>
- rel 0.2
- fix MAKEDEV.usb to call installed file, which always has execute permission
- add a few comments to %ifarch/%endif code to help debugging above problem
- update ext3 to 0.0.5d, update ext3 with 2.2.18 ext2 fixes (not LFS yet)
- remove obsolete linux-2.2.14-loop patch (replaced by linux-2.2.16-loop)

* Tue Dec 12 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 0.1
- update 2.2.18 release
- update 2.2.18aa1 and ide.2.2.18.1209
- update aacraid-1.0.6
- small fixed ext3-0.0.5-2.2.18TL.patch
- remove patches for 2.2.18preXX
- BOOT, turn off MODVERSION and build alsa

* Tue Dec 12 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 1.0.7
- added loop-F1 patch for mongoose
- ext3, build static for up and smp kernel, module for BOOT

* Tue Dec 12 2000 Andreas Dilger <adilger@turbolinux.com>
- rel 1.0.6
- add reiserfs 3.5.28 patch
- disable reiserfs in Alpha, S/390 configs (not supported there yet)
- fix RCS tag breakage in kdb patch

* Tue Dec 12 2000 Kazutomo Yoshii <kazutomo@turbolinux.co.jp>
- rel 1.0.5
- fixed abound  buildKernel()

* Mon Dec 11 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 1.0.4
- update pre-patch-2.2.18-27 and 2.2.18pre27aa, this is small fixed 2.2.18pre24aa1
- update alsa-0.5.10
- added support megaraid 493 by 107b
- turn on EXT3 REISER

* Sun Dec 7 2000 Andreas Dilger <adilger@turbolinux.com>
- rel 1.0.3
- add ext3-0.0.5c patch
- remove loopdiscard patch (really should be for developers only)

* Sun Dec 3 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 1.0.2
- readded auto_software_raid, userlink, iBCS
- fixed unresolved symbole modules.  "__bad_udelay"
- fixed i60uscsi VIRT_TO_BUS
- uselink turn off wait_queue and init_waitqueue_head for 2.2.18
- tulip.c added support ADMtek Comet
- Makefile added E100_MODULES E1000_MODULES, install to net

* Wed Nov 29 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 1.0.1 development release
- added pre-patch-2.2.18-21
- added 2.2.18pre21aa2
- update pcmcia-cs 3.1.22
- removed async
- update e100 ver 1.3.20
- update e100 ver 2.5.14
- added 3c990 added (need licence check)
- removed I810Gtt (include kernel)
- update ipvs 1.0.0
- fixed many patchs for 2.2.18
- not available yet. udf, auto_software_raid, userlink, iBCS

* Wed Sep 20 2000 Go Taniguchi <go@turbolinux.co.jp>
- release 1

* Tue Sep 19 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.9
- remove linux-2.2.16-scsi-offline.patch, aic7xxx had ploblem.
- Sorry Andreas, New future merge to 1.0.1 again.

* Sun Sep 17 2000 Andreas Dilger <adilger@turoblinux.com>
- 0.8.1
- update reiserfs to 3.5.25
- update lvm-0.8final-2.2.16TL.patch to fix problem with lvm snapshots
- change Prereq to be file /sbin/ldconfig instead of package ldconfig,
  as on TLW-6.0 (US) this package is called ld.so and not ldconfig
- have top-level COMPILER variable to allow building with egcs or gcc
- add ext2 online resizing patch (selectable)

* Sat Sep 16 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.8
- change nls patch to linux-2.2.18pre7's one
- added hdlc PC300 patch from Andrew IP <aip@turbolinux.com>
- change LVM config m to y

* Thu Sep 14 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.7
- update DAC960-2.2.9
- support 3c556
- added patch scsi-reservation and scsi-offline

* Thu Sep 14 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.6
- update cyc_async-6.5.9 from Andrew IP <aip@turbolinux.com>

* Mon Sep 11 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.5
- update alsa 0.5.9c
- fixed vmscan.patch 

* Fri Sep 8 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 0.4
- Switch ON LVM!

* Thu Sep 7 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 0.3
- fixed linux-2.2.17-bigmem-no-lfs.patch from Andreas Dilger
- refixed spec file for alpha from Steve Baur
- update UniIDE 20000904

* Wed Sep 6 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 0.2
- update I810Gtt for i815

* Tue Sep 5 2000 SL Baur  <steve@turbolinux.co.jp>
- tweaks to get something working on Alpha:
- added additional modules (modified alpha config patch)

* Tue Sep 5 2000 Go Taniguchi <go@turbolinux.co.jp>
- linux-2.2.17 release
- starting rel 0.1

* Sat Sep 2 2000 Go Taniguchi <go@turbolinux.co.jp>
- update 2.2.17-pre20
- update pcmcia-cs-3.1.20
- update alsa-driver-0.5.9b
- sis900 update 1.06.03
- added patch linux-2.2.16-ipv6-udp.patch
- some patch fixed for 2.2.17
- update UniIDE 20000825
- emu10k1 have kernl source, remove emu10k1 source
- debash, support rpm-3.0.5 and 4
- man dir use %{_mandir} for FHS

* Fri Aug 18 2000 Go Taniguchi <go@turbolinux.co.jp>
- release 3
- module ide-floopy, ZIP noizy message fix.
- modules e100, if smp_cpu >= 2, use io port.
- fixed files sections.

* Tue Aug 1 2000 Go Taniguchi <go@turbolinux.co.jp>
- 2.2
- added Qlogic QLA2x00 QLC Fiber Chanel SCSI driver
- added Qlogic ISP1280/12160 Ultra2/Ultra3 SCSI driver
- added SMC ISA/MCA Token Ling adapter driver
- refixed e100-1.1.1 with 8CPUs NFS
- if build Miracle, build name to kernel@miraclelinux.com

* Fri Jul 28 2000 Go Taniguchi <go@turbolinux.co.jp>
- 2.1
- update pcmcia-cs 3.1.19
- update LVS ipvs-0.9.15-2.2.16 
- update aacraid-1.0.3i
- refixed e100-1.1.1 with 8CPUs.
- update cyclades-2.3.2.8
- reenabeled USB
- fixed egcs.patch 

* Fri Jul 21 2000 Go Taniguchi <go@turbolinux.co.jp>
- rel 2
- fixed e100-1.1.1 with 8CPUs.
- fixed isofs dir.c, boundarie and move sector.

* Wed Jul 19 2000  Daniel Fang <danf@turbolinux.com.cn>
- Fix pctel unresolve symbol problem I have to back the old one

* Tue Jul 18 2000 Go Taniguchi <go@turbolinux.co.jp>
- 1.4
- moduled SCSI_BLK_SR
- update e1000-2.0.6
- added CLModem driver
- added Equinox driver if we have source
- added patch kernel-cp950-3.6 for fix euc-jp
- remove ,megaraid-1b08b dose not work Some magaraide
- turn on CONFIG_MINIX_FS for BOOT kernel
- turn off CONFIG_KDB, if turn on that, we have some problems.

* Thu Jul 14 2000 Andreas Dilger <adilger@turoblinux.com>
- 1.3.1
- update to ext3-0.0.2f-2.2.16TL.patch
- update ext3-0.0.2f-aed-1.patch
- update kdb-ext3-0.0.2f-2.2.16.patch
- added lvm-0.8final-2.2.16TL.patch
- patches updated (but not referenced in spec file) for 2.2.17-pre9:
  linux-2.2.17pre9-bigmem-no-lfs.patch and ide.2.2.17pre9.20000619.patch
- config files for i386 and alpha updated for new 2.2.17-pre9 options
- updated udf, ext3 and reiserfs patches to patch linux/fs/Makefile
  properly if one of them is not included in the kernel build

* Fri Jul 14 2000  Daniel Fang <danf@turbolinux.com.cn>
- 1.3
- Upgrade Reiserfs to 3.5.23
- Resign the SPEC format

* Sun Jul 9 2000 Go Taniguchi <go@turbolinux.co.jp>
- 1.2
- update pcmcia-3.1.17
- update alsa-0.5.8b
- fixed SetupKernelSource.sh for BOOT kernel
- update aic7xxx-5.1.31
- update e100-1.1.1 with our fix
- added e1000-1.0.3
- fixed nls_cp932 euc-jp (but we have problem, broken filename if writing)
- added psaux patch for few system, that mouse dose not start.
- added usb-2.4.0 usb_enabler for SONY VAIO
- added aacraid-1.0.3 (New PERCRAID, NetRaid)
- update DAC960-2.2.6. support eXtremeRAID 2000/3000 and AcceleRAID 352/170
- update megaraid-1b08b. support MegaRAID 493
- update acenic-0.45
- added vga16fb.patch for FB_VGA with EtherExpress100x
- added iomega_clik patch
- support Adico AE310-TX by tulip
- added and support ext3-0.0.2d
- turn on kdb
- selectable reiserfs or ext3
- added unicon-lite for BOOT kernl
- selectable unicon turn on/off
- added pctel driver
- selectable unicon turn on/off
- added pctel driver
- added MAKEDEV.usb and /dev/usb,/dev/input
- now support ServeRAID 4 by ips
- patch, change parameter semopm by /proc/sys/kernel/semopm for oracle

* Thu Jul 5 2000 Robert Read <rread@turbolinux.com>
- Support two new types of kernels for s/390.
- Use more explicit %ifarch in certain places

* Mon Jun 26 2000 Scott Taylor <voortrekker@turbolinux.com>
- added linux-2.2.16-s390-hwc.diff patch

* Thu Jun 22 2000 Robert Read <rread@turbolinux.com>
- do make image for s390
- add s390 for extra packages

* Wed Jun 21 2000 Go Taniguchi <go@turbolinux.co.jp>
- 0.6
- turn on CONFIG_FILTER
- turn off CONFIG_FB_ATY
- fixed conflict

* Fri Jun 16 2000 Scott Taylor <voortrekker@turbolinux.com>
- added s390 patches and SPEC modifications and .config

* Wed Jun 14 2000 Go Taniguchi <go@turbolinux.co.jp>
- suport Alpha by SL Baur <stave@turbolinux.co.jp>
- small fix bigmem
- small fix e100
- disabled CONFIG_FB_VGA16, It has problem by few VGA.

* Tue Jun 13 2000 Go Taniguchi <go@turbolinux.co.jp>
- added pre-patch-2.2.17-1 for 2.2.16 errata fix
- update pcmcia-cs 3.1.16
- update aic7xxx-5.1.30
- fix bigmem patch
- added ide.2.2.16-pre7.20000509 with our fix
- added kernel-2.2.17pre1-mingoraid.patch with our fix
- update emu10k1 20000530
- update i810gtt-0.1-6
- changed raw-2.2.14-tl.diff from matt
- now, ASYNC and VFAT jp, BIGMEM disabled.

* Thu Jun 8 2000 Go Taniguchi <go@turbolinux.co.jp>
- 2.2.16-0.1
- update kernel 2.2.16
- now not availvle BIGMEM and UniIDE and VFAT jP

* Wed Jun 7 2000 Go Taniguchi <go@turbolinux.co.jp>
- 8.3
- unificatin US and Japan version.

* Mon May 29 2000 Go Taniguchi <go@turbolinux.co.jp>
- 8.2
- update pcmcia-cs-3.1.15

* Mon May 29 2000 Go Taniguchi <go@turbolinux.co.jp>
- 8.1
- USB mouse and keybord support for UHCI and OHCI
- support PCMCIA SMC EZ 10/100 Fast Ethernet and OEM

* Wed May 24 2000 Go Taniguchi <go@turbolinux.co.jp>
- 8
- remove 53c8xx new version patch 53c875a dose not work
- fix %post AGPGART section
- new fixed nmi_hook.patch

* Tue May 23 2000 Go Taniguchi <go@turbolinux.co.jp>
- 7
- ide.2.2.15.20000509.patch define SMP_DEBUG, this is dose not work on 8 CPUS
- i2o default disabled, kernel option "i2opci" define for enable.

* Tue May 16 2000 Go Taniguchi <go@turbolinux.co.jp>
- 6
- update 3c59x.c v0.99L, this is my mistake.
- update linux-2.2.14-bigmem-raw.patch
- add support DPT I2O RAID card

* Sat May 13 2000 Go Taniguchi <go@turbolinux.co.jp>
- Relese 5
- used fixed nmihook patch
- added package source Requires
- update 53c8xx s04-d00

* Fri May 12 2000 Go Taniguchi <go@turbolinux.co.jp>
- 4.1
- fix sources's pcmcia etc config set
- fix wireless_tools.20 making include path, no need /usr/include/linux 
- pcmcia pnp disabled, IRQ resource is very poor
- reinclude ide.2.2.15.20000509.patch.bz2, this is Good!

* Sat May 6 2000 Go Taniguchi <go@turbolinux.co.jp>
- Relese 4
- remove ide.2.2.15.20000504. ide-dma have small problem, may be...
- add support PIIX4x
- update rtl8139 v1.08

* Fri May 5 2000 Go Taniguchi <go@turbolinux.co.jp>
- fix spec file, "SEIRI SEITON"
- enables pcmcia pnp set
- update emu10k1-20000409
- support pcmcia Allied Telesis LA-PCM

* Thu May 4 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.8
- True 2.2.15 release
- update ide.2.2.15.20000504
- support pcmcia tulip_cb include corega FastEtherII and Allied CardBus V2
- fix pcmcia add config
- added SetupKernelSource.sh for smp source
- making /etc/sysconfig/pcmcia pcmcia-cs in %post
- remove pcmcia source's config.out
- include pcmcia wireless_tools

* Mon May 1 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.7
- fix Intel i840 64bit PCI PARITY
- fix /etc/pcmcia files list
- update aic7xxx 5.1.29
- update ide driver 2.2.15-19.20000420
- fix %postun source, add %postun headers and %post headers
- support VIA VT6102 Rhine
- Diet Diet BOOT kernel
- pcmcia-cs i82365, fix RICOH controller irq

* Fri Apr 21 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.6
- update 2.2.15pre20
- include tcp retransmit_synack patch
- support Winbond 89C840

* Tue Apr 18 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.5
- include kernel hook, nmihook.patch
- small fix, serial SMP fix patch
- PCMCIA PnP BIOS resource checking is no
- pcmcia daemon, default off

* Mon Apr 17 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.4
- update 2.2.15pre19
- add UDF fs driver, read only.
- reinclide ibcs package
- include vfat-jp, default kanji code is sjis
- i2opci detect AMI megarade, if detect not init, same Intel1960 VENDERID PCIID
- pcmcia support Corega FirstEther
- update pcmcia 3.1.4
- add serial SMP fix patch

* Wed Apr 12 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.3
- update 2.2.15pre18
- reinclude alsa driver
- reinclude pcmcia pcnet_cs
- readd and update pcmcia nin_cs, NinjaSCSI3-0.4.1
- readd kernel-utils
- I2OPCI is include, but default is disable. megaraid is hang .
- if useing I2OPCI , never add new option "i2opci" at boot: prompt
- or append lilo.conf append="i2opci"
- add modules I2OSCSI and I2OBLOCK
- update IDE Driver, ide.2.2.15-17.20000405
- fix SPEC file

* Fri Apr 7 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.2
- downgrade kaio 1.1, 1.2 is dose not work

* Mon Apr 3 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3.1
- update 2.2.15pre17

* Sun Apr 2 2000 Go Taniguchi <go@turbolinux.co.jp>
- 3
- update 2.2.15pre16
- build egcs 1.1.2
- change bigmem patch to SuSE from SGI
- change raw driver to RH from SGI
- add SGI async KAIO
- delete SGI kernel crash dump
- change to module I2O pci, only enable I2O core. megaraid hang.
- enable QUOTA 
- delete alsa driver
- fix many patch

* Sat Mar 25 2000 Go Taniguchi <go@turbolinux.co.jp>
- 2
- update 2.2.15pre15
- update and enable auto RAID raid-2.2.14-B1
- update IDE DMA driver patch to 2.2.15-15.20000317
- update and enable pcmcia 3.1.13
- add e100 and 3c90x offical drivers, update via-rihne
- enable bigmem
- add and enable SGI raw driver
- add and enable SGI kernel crash dump 
- separate pcmcia-cs and header packages
- enable I2O pci for dell server
- disable QUOTA, may be pre15 bug
- reject vfat jp patch, disabled
- replace ibcs, dose not compile with bigmem

* Fri Mar 10 2000 Kiichiro Naka <knaka@turbolinux.co.jp>
- 1
- fixed many
